/**
 * Autogenerated by Avro
 *
 * DO NOT EDIT DIRECTLY
 */
package TwoClusterJoin.Avro;

import org.apache.avro.message.BinaryMessageDecoder;
import org.apache.avro.message.BinaryMessageEncoder;
import org.apache.avro.message.SchemaStore;
import org.apache.avro.specific.SpecificData;

@org.apache.avro.specific.AvroGenerated
public class SearchEvent extends org.apache.avro.specific.SpecificRecordBase implements org.apache.avro.specific.SpecificRecord {
  private static final long serialVersionUID = -7536764992193977399L;
  public static final org.apache.avro.Schema SCHEMA$ = new org.apache.avro.Schema.Parser().parse("{\"type\":\"record\",\"name\":\"SearchEvent\",\"namespace\":\"com.ixigo.avro\",\"fields\":[{\"name\":\"searchPrimaryId\",\"type\":[\"null\",{\"type\":\"string\",\"avro.java.string\":\"String\"}],\"default\":null},{\"name\":\"userId\",\"type\":[\"null\",{\"type\":\"string\",\"avro.java.string\":\"String\"}],\"default\":null},{\"name\":\"uuid\",\"type\":[\"null\",{\"type\":\"string\",\"avro.java.string\":\"String\"}],\"default\":null},{\"name\":\"adId\",\"type\":[\"null\",{\"type\":\"string\",\"avro.java.string\":\"String\"}],\"default\":null},{\"name\":\"fingerPrint\",\"type\":[\"null\",{\"type\":\"string\",\"avro.java.string\":\"String\"}],\"default\":null},{\"name\":\"deviceId\",\"type\":[\"null\",{\"type\":\"string\",\"avro.java.string\":\"String\"}],\"default\":null},{\"name\":\"latitude\",\"type\":\"double\",\"default\":-1},{\"name\":\"longitude\",\"type\":\"double\",\"default\":-1},{\"name\":\"ip\",\"type\":[\"null\",{\"type\":\"string\",\"avro.java.string\":\"String\"}],\"default\":null},{\"name\":\"osVersion\",\"type\":[\"null\",{\"type\":\"string\",\"avro.java.string\":\"String\"}],\"default\":null},{\"name\":\"deviceOs\",\"type\":[\"null\",{\"type\":\"string\",\"avro.java.string\":\"String\"}],\"default\":null},{\"name\":\"clientId\",\"type\":[\"null\",{\"type\":\"string\",\"avro.java.string\":\"String\"}],\"default\":null},{\"name\":\"appVersion\",\"type\":[\"null\",{\"type\":\"string\",\"avro.java.string\":\"String\"}],\"default\":null},{\"name\":\"originCity\",\"type\":[\"null\",{\"type\":\"string\",\"avro.java.string\":\"String\"}],\"default\":null},{\"name\":\"originCode\",\"type\":[\"null\",{\"type\":\"string\",\"avro.java.string\":\"String\"}],\"default\":null},{\"name\":\"originState\",\"type\":[\"null\",{\"type\":\"string\",\"avro.java.string\":\"String\"}],\"default\":null},{\"name\":\"originCountry\",\"type\":[\"null\",{\"type\":\"string\",\"avro.java.string\":\"String\"}],\"default\":null},{\"name\":\"destinationCity\",\"type\":[\"null\",{\"type\":\"string\",\"avro.java.string\":\"String\"}],\"default\":null},{\"name\":\"destinationCode\",\"type\":[\"null\",{\"type\":\"string\",\"avro.java.string\":\"String\"}],\"default\":null},{\"name\":\"destinationState\",\"type\":[\"null\",{\"type\":\"string\",\"avro.java.string\":\"String\"}],\"default\":null},{\"name\":\"destinationCountry\",\"type\":[\"null\",{\"type\":\"string\",\"avro.java.string\":\"String\"}],\"default\":null},{\"name\":\"product\",\"type\":[\"null\",{\"type\":\"string\",\"avro.java.string\":\"String\"}],\"default\":null},{\"name\":\"cabinClass\",\"type\":[\"null\",{\"type\":\"string\",\"avro.java.string\":\"String\"}],\"default\":null},{\"name\":\"timestamp\",\"type\":\"long\"},{\"name\":\"walletBalance\",\"type\":[\"null\",{\"type\":\"string\",\"avro.java.string\":\"String\",\"java-class\":\"java.math.BigDecimal\"}],\"default\":null},{\"name\":\"numOfAdult\",\"type\":\"int\",\"default\":1},{\"name\":\"numOfChildren\",\"type\":\"int\",\"default\":0},{\"name\":\"departureDate\",\"type\":[\"null\",{\"type\":\"int\",\"logicalType\":\"date\"}],\"default\":null},{\"name\":\"arrivalDate\",\"type\":[\"null\",{\"type\":\"int\",\"logicalType\":\"date\"}],\"default\":null}]}");
  public static org.apache.avro.Schema getClassSchema() { return SCHEMA$; }

  private static SpecificData MODEL$ = new SpecificData();
static {
    MODEL$.addLogicalTypeConversion(new org.apache.avro.data.TimeConversions.DateConversion());
    MODEL$.addLogicalTypeConversion(new org.apache.avro.Conversions.DecimalConversion());
  }

  private static final BinaryMessageEncoder<SearchEvent> ENCODER =
      new BinaryMessageEncoder<SearchEvent>(MODEL$, SCHEMA$);

  private static final BinaryMessageDecoder<SearchEvent> DECODER =
      new BinaryMessageDecoder<SearchEvent>(MODEL$, SCHEMA$);

  /**
   * Return the BinaryMessageEncoder instance used by this class.
   * @return the message encoder used by this class
   */
  public static BinaryMessageEncoder<SearchEvent> getEncoder() {
    return ENCODER;
  }

  /**
   * Return the BinaryMessageDecoder instance used by this class.
   * @return the message decoder used by this class
   */
  public static BinaryMessageDecoder<SearchEvent> getDecoder() {
    return DECODER;
  }

  /**
   * Create a new BinaryMessageDecoder instance for this class that uses the specified {@link SchemaStore}.
   * @param resolver a {@link SchemaStore} used to find schemas by fingerprint
   * @return a BinaryMessageDecoder instance for this class backed by the given SchemaStore
   */
  public static BinaryMessageDecoder<SearchEvent> createDecoder(SchemaStore resolver) {
    return new BinaryMessageDecoder<SearchEvent>(MODEL$, SCHEMA$, resolver);
  }

  /**
   * Serializes this SearchEvent to a ByteBuffer.
   * @return a buffer holding the serialized data for this instance
   * @throws java.io.IOException if this instance could not be serialized
   */
  public java.nio.ByteBuffer toByteBuffer() throws java.io.IOException {
    return ENCODER.encode(this);
  }

  /**
   * Deserializes a SearchEvent from a ByteBuffer.
   * @param b a byte buffer holding serialized data for an instance of this class
   * @return a SearchEvent instance decoded from the given buffer
   * @throws java.io.IOException if the given bytes could not be deserialized into an instance of this class
   */
  public static SearchEvent fromByteBuffer(
      java.nio.ByteBuffer b) throws java.io.IOException {
    return DECODER.decode(b);
  }

   private String searchPrimaryId;
   private String userId;
   private String uuid;
   private String adId;
   private String fingerPrint;
   private String deviceId;
   private double latitude;
   private double longitude;
   private String ip;
   private String osVersion;
   private String deviceOs;
   private String clientId;
   private String appVersion;
   private String originCity;
   private String originCode;
   private String originState;
   private String originCountry;
   private String destinationCity;
   private String destinationCode;
   private String destinationState;
   private String destinationCountry;
   private String product;
   private String cabinClass;
   private long timestamp;
   private java.math.BigDecimal walletBalance;
   private int numOfAdult;
   private int numOfChildren;
   private java.time.LocalDate departureDate;
   private java.time.LocalDate arrivalDate;

  /**
   * Default constructor.  Note that this does not initialize fields
   * to their default values from the schema.  If that is desired then
   * one should use <code>newBuilder()</code>.
   */
  public SearchEvent() {}

  /**
   * All-args constructor.
   * @param searchPrimaryId The new value for searchPrimaryId
   * @param userId The new value for userId
   * @param uuid The new value for uuid
   * @param adId The new value for adId
   * @param fingerPrint The new value for fingerPrint
   * @param deviceId The new value for deviceId
   * @param latitude The new value for latitude
   * @param longitude The new value for longitude
   * @param ip The new value for ip
   * @param osVersion The new value for osVersion
   * @param deviceOs The new value for deviceOs
   * @param clientId The new value for clientId
   * @param appVersion The new value for appVersion
   * @param originCity The new value for originCity
   * @param originCode The new value for originCode
   * @param originState The new value for originState
   * @param originCountry The new value for originCountry
   * @param destinationCity The new value for destinationCity
   * @param destinationCode The new value for destinationCode
   * @param destinationState The new value for destinationState
   * @param destinationCountry The new value for destinationCountry
   * @param product The new value for product
   * @param cabinClass The new value for cabinClass
   * @param timestamp The new value for timestamp
   * @param walletBalance The new value for walletBalance
   * @param numOfAdult The new value for numOfAdult
   * @param numOfChildren The new value for numOfChildren
   * @param departureDate The new value for departureDate
   * @param arrivalDate The new value for arrivalDate
   */
  public SearchEvent(String searchPrimaryId, String userId, String uuid, String adId, String fingerPrint, String deviceId, Double latitude, Double longitude, String ip, String osVersion, String deviceOs, String clientId, String appVersion, String originCity, String originCode, String originState, String originCountry, String destinationCity, String destinationCode, String destinationState, String destinationCountry, String product, String cabinClass, Long timestamp, java.math.BigDecimal walletBalance, Integer numOfAdult, Integer numOfChildren, java.time.LocalDate departureDate, java.time.LocalDate arrivalDate) {
    this.searchPrimaryId = searchPrimaryId;
    this.userId = userId;
    this.uuid = uuid;
    this.adId = adId;
    this.fingerPrint = fingerPrint;
    this.deviceId = deviceId;
    this.latitude = latitude;
    this.longitude = longitude;
    this.ip = ip;
    this.osVersion = osVersion;
    this.deviceOs = deviceOs;
    this.clientId = clientId;
    this.appVersion = appVersion;
    this.originCity = originCity;
    this.originCode = originCode;
    this.originState = originState;
    this.originCountry = originCountry;
    this.destinationCity = destinationCity;
    this.destinationCode = destinationCode;
    this.destinationState = destinationState;
    this.destinationCountry = destinationCountry;
    this.product = product;
    this.cabinClass = cabinClass;
    this.timestamp = timestamp;
    this.walletBalance = walletBalance;
    this.numOfAdult = numOfAdult;
    this.numOfChildren = numOfChildren;
    this.departureDate = departureDate;
    this.arrivalDate = arrivalDate;
  }

  public org.apache.avro.specific.SpecificData getSpecificData() { return MODEL$; }
  public org.apache.avro.Schema getSchema() { return SCHEMA$; }
  // Used by DatumWriter.  Applications should not call.
  public Object get(int field$) {
    switch (field$) {
    case 0: return searchPrimaryId;
    case 1: return userId;
    case 2: return uuid;
    case 3: return adId;
    case 4: return fingerPrint;
    case 5: return deviceId;
    case 6: return latitude;
    case 7: return longitude;
    case 8: return ip;
    case 9: return osVersion;
    case 10: return deviceOs;
    case 11: return clientId;
    case 12: return appVersion;
    case 13: return originCity;
    case 14: return originCode;
    case 15: return originState;
    case 16: return originCountry;
    case 17: return destinationCity;
    case 18: return destinationCode;
    case 19: return destinationState;
    case 20: return destinationCountry;
    case 21: return product;
    case 22: return cabinClass;
    case 23: return timestamp;
    case 24: return walletBalance;
    case 25: return numOfAdult;
    case 26: return numOfChildren;
    case 27: return departureDate;
    case 28: return arrivalDate;
    default: throw new org.apache.avro.AvroRuntimeException("Bad index");
    }
  }

  // Used by DatumReader.  Applications should not call.
  @SuppressWarnings(value="unchecked")
  public void put(int field$, Object value$) {
    switch (field$) {
    case 0: searchPrimaryId = (String)value$; break;
    case 1: userId = (String)value$; break;
    case 2: uuid = (String)value$; break;
    case 3: adId = (String)value$; break;
    case 4: fingerPrint = (String)value$; break;
    case 5: deviceId = (String)value$; break;
    case 6: latitude = (Double)value$; break;
    case 7: longitude = (Double)value$; break;
    case 8: ip = (String)value$; break;
    case 9: osVersion = (String)value$; break;
    case 10: deviceOs = (String)value$; break;
    case 11: clientId = (String)value$; break;
    case 12: appVersion = (String)value$; break;
    case 13: originCity = (String)value$; break;
    case 14: originCode = (String)value$; break;
    case 15: originState = (String)value$; break;
    case 16: originCountry = (String)value$; break;
    case 17: destinationCity = (String)value$; break;
    case 18: destinationCode = (String)value$; break;
    case 19: destinationState = (String)value$; break;
    case 20: destinationCountry = (String)value$; break;
    case 21: product = (String)value$; break;
    case 22: cabinClass = (String)value$; break;
    case 23: timestamp = (Long)value$; break;
    case 24: walletBalance = (java.math.BigDecimal)value$; break;
    case 25: numOfAdult = (Integer)value$; break;
    case 26: numOfChildren = (Integer)value$; break;
    case 27: departureDate = (java.time.LocalDate)value$; break;
    case 28: arrivalDate = (java.time.LocalDate)value$; break;
    default: throw new org.apache.avro.AvroRuntimeException("Bad index");
    }
  }

  /**
   * Gets the value of the 'searchPrimaryId' field.
   * @return The value of the 'searchPrimaryId' field.
   */
  public String getSearchPrimaryId() {
    return searchPrimaryId;
  }


  /**
   * Sets the value of the 'searchPrimaryId' field.
   * @param value the value to set.
   */
  public void setSearchPrimaryId(String value) {
    this.searchPrimaryId = value;
  }

  /**
   * Gets the value of the 'userId' field.
   * @return The value of the 'userId' field.
   */
  public String getUserId() {
    return userId;
  }


  /**
   * Sets the value of the 'userId' field.
   * @param value the value to set.
   */
  public void setUserId(String value) {
    this.userId = value;
  }

  /**
   * Gets the value of the 'uuid' field.
   * @return The value of the 'uuid' field.
   */
  public String getUuid() {
    return uuid;
  }


  /**
   * Sets the value of the 'uuid' field.
   * @param value the value to set.
   */
  public void setUuid(String value) {
    this.uuid = value;
  }

  /**
   * Gets the value of the 'adId' field.
   * @return The value of the 'adId' field.
   */
  public String getAdId() {
    return adId;
  }


  /**
   * Sets the value of the 'adId' field.
   * @param value the value to set.
   */
  public void setAdId(String value) {
    this.adId = value;
  }

  /**
   * Gets the value of the 'fingerPrint' field.
   * @return The value of the 'fingerPrint' field.
   */
  public String getFingerPrint() {
    return fingerPrint;
  }


  /**
   * Sets the value of the 'fingerPrint' field.
   * @param value the value to set.
   */
  public void setFingerPrint(String value) {
    this.fingerPrint = value;
  }

  /**
   * Gets the value of the 'deviceId' field.
   * @return The value of the 'deviceId' field.
   */
  public String getDeviceId() {
    return deviceId;
  }


  /**
   * Sets the value of the 'deviceId' field.
   * @param value the value to set.
   */
  public void setDeviceId(String value) {
    this.deviceId = value;
  }

  /**
   * Gets the value of the 'latitude' field.
   * @return The value of the 'latitude' field.
   */
  public double getLatitude() {
    return latitude;
  }


  /**
   * Sets the value of the 'latitude' field.
   * @param value the value to set.
   */
  public void setLatitude(double value) {
    this.latitude = value;
  }

  /**
   * Gets the value of the 'longitude' field.
   * @return The value of the 'longitude' field.
   */
  public double getLongitude() {
    return longitude;
  }


  /**
   * Sets the value of the 'longitude' field.
   * @param value the value to set.
   */
  public void setLongitude(double value) {
    this.longitude = value;
  }

  /**
   * Gets the value of the 'ip' field.
   * @return The value of the 'ip' field.
   */
  public String getIp() {
    return ip;
  }


  /**
   * Sets the value of the 'ip' field.
   * @param value the value to set.
   */
  public void setIp(String value) {
    this.ip = value;
  }

  /**
   * Gets the value of the 'osVersion' field.
   * @return The value of the 'osVersion' field.
   */
  public String getOsVersion() {
    return osVersion;
  }


  /**
   * Sets the value of the 'osVersion' field.
   * @param value the value to set.
   */
  public void setOsVersion(String value) {
    this.osVersion = value;
  }

  /**
   * Gets the value of the 'deviceOs' field.
   * @return The value of the 'deviceOs' field.
   */
  public String getDeviceOs() {
    return deviceOs;
  }


  /**
   * Sets the value of the 'deviceOs' field.
   * @param value the value to set.
   */
  public void setDeviceOs(String value) {
    this.deviceOs = value;
  }

  /**
   * Gets the value of the 'clientId' field.
   * @return The value of the 'clientId' field.
   */
  public String getClientId() {
    return clientId;
  }


  /**
   * Sets the value of the 'clientId' field.
   * @param value the value to set.
   */
  public void setClientId(String value) {
    this.clientId = value;
  }

  /**
   * Gets the value of the 'appVersion' field.
   * @return The value of the 'appVersion' field.
   */
  public String getAppVersion() {
    return appVersion;
  }


  /**
   * Sets the value of the 'appVersion' field.
   * @param value the value to set.
   */
  public void setAppVersion(String value) {
    this.appVersion = value;
  }

  /**
   * Gets the value of the 'originCity' field.
   * @return The value of the 'originCity' field.
   */
  public String getOriginCity() {
    return originCity;
  }


  /**
   * Sets the value of the 'originCity' field.
   * @param value the value to set.
   */
  public void setOriginCity(String value) {
    this.originCity = value;
  }

  /**
   * Gets the value of the 'originCode' field.
   * @return The value of the 'originCode' field.
   */
  public String getOriginCode() {
    return originCode;
  }


  /**
   * Sets the value of the 'originCode' field.
   * @param value the value to set.
   */
  public void setOriginCode(String value) {
    this.originCode = value;
  }

  /**
   * Gets the value of the 'originState' field.
   * @return The value of the 'originState' field.
   */
  public String getOriginState() {
    return originState;
  }


  /**
   * Sets the value of the 'originState' field.
   * @param value the value to set.
   */
  public void setOriginState(String value) {
    this.originState = value;
  }

  /**
   * Gets the value of the 'originCountry' field.
   * @return The value of the 'originCountry' field.
   */
  public String getOriginCountry() {
    return originCountry;
  }


  /**
   * Sets the value of the 'originCountry' field.
   * @param value the value to set.
   */
  public void setOriginCountry(String value) {
    this.originCountry = value;
  }

  /**
   * Gets the value of the 'destinationCity' field.
   * @return The value of the 'destinationCity' field.
   */
  public String getDestinationCity() {
    return destinationCity;
  }


  /**
   * Sets the value of the 'destinationCity' field.
   * @param value the value to set.
   */
  public void setDestinationCity(String value) {
    this.destinationCity = value;
  }

  /**
   * Gets the value of the 'destinationCode' field.
   * @return The value of the 'destinationCode' field.
   */
  public String getDestinationCode() {
    return destinationCode;
  }


  /**
   * Sets the value of the 'destinationCode' field.
   * @param value the value to set.
   */
  public void setDestinationCode(String value) {
    this.destinationCode = value;
  }

  /**
   * Gets the value of the 'destinationState' field.
   * @return The value of the 'destinationState' field.
   */
  public String getDestinationState() {
    return destinationState;
  }


  /**
   * Sets the value of the 'destinationState' field.
   * @param value the value to set.
   */
  public void setDestinationState(String value) {
    this.destinationState = value;
  }

  /**
   * Gets the value of the 'destinationCountry' field.
   * @return The value of the 'destinationCountry' field.
   */
  public String getDestinationCountry() {
    return destinationCountry;
  }


  /**
   * Sets the value of the 'destinationCountry' field.
   * @param value the value to set.
   */
  public void setDestinationCountry(String value) {
    this.destinationCountry = value;
  }

  /**
   * Gets the value of the 'product' field.
   * @return The value of the 'product' field.
   */
  public String getProduct() {
    return product;
  }


  /**
   * Sets the value of the 'product' field.
   * @param value the value to set.
   */
  public void setProduct(String value) {
    this.product = value;
  }

  /**
   * Gets the value of the 'cabinClass' field.
   * @return The value of the 'cabinClass' field.
   */
  public String getCabinClass() {
    return cabinClass;
  }


  /**
   * Sets the value of the 'cabinClass' field.
   * @param value the value to set.
   */
  public void setCabinClass(String value) {
    this.cabinClass = value;
  }

  /**
   * Gets the value of the 'timestamp' field.
   * @return The value of the 'timestamp' field.
   */
  public long getTimestamp() {
    return timestamp;
  }


  /**
   * Sets the value of the 'timestamp' field.
   * @param value the value to set.
   */
  public void setTimestamp(long value) {
    this.timestamp = value;
  }

  /**
   * Gets the value of the 'walletBalance' field.
   * @return The value of the 'walletBalance' field.
   */
  public java.math.BigDecimal getWalletBalance() {
    return walletBalance;
  }


  /**
   * Sets the value of the 'walletBalance' field.
   * @param value the value to set.
   */
  public void setWalletBalance(java.math.BigDecimal value) {
    this.walletBalance = value;
  }

  /**
   * Gets the value of the 'numOfAdult' field.
   * @return The value of the 'numOfAdult' field.
   */
  public int getNumOfAdult() {
    return numOfAdult;
  }


  /**
   * Sets the value of the 'numOfAdult' field.
   * @param value the value to set.
   */
  public void setNumOfAdult(int value) {
    this.numOfAdult = value;
  }

  /**
   * Gets the value of the 'numOfChildren' field.
   * @return The value of the 'numOfChildren' field.
   */
  public int getNumOfChildren() {
    return numOfChildren;
  }


  /**
   * Sets the value of the 'numOfChildren' field.
   * @param value the value to set.
   */
  public void setNumOfChildren(int value) {
    this.numOfChildren = value;
  }

  /**
   * Gets the value of the 'departureDate' field.
   * @return The value of the 'departureDate' field.
   */
  public java.time.LocalDate getDepartureDate() {
    return departureDate;
  }


  /**
   * Sets the value of the 'departureDate' field.
   * @param value the value to set.
   */
  public void setDepartureDate(java.time.LocalDate value) {
    this.departureDate = value;
  }

  /**
   * Gets the value of the 'arrivalDate' field.
   * @return The value of the 'arrivalDate' field.
   */
  public java.time.LocalDate getArrivalDate() {
    return arrivalDate;
  }


  /**
   * Sets the value of the 'arrivalDate' field.
   * @param value the value to set.
   */
  public void setArrivalDate(java.time.LocalDate value) {
    this.arrivalDate = value;
  }

  /**
   * Creates a new SearchEvent RecordBuilder.
   * @return A new SearchEvent RecordBuilder
   */
  public static SearchEvent.Builder newBuilder() {
    return new SearchEvent.Builder();
  }

  /**
   * Creates a new SearchEvent RecordBuilder by copying an existing Builder.
   * @param other The existing builder to copy.
   * @return A new SearchEvent RecordBuilder
   */
  public static SearchEvent.Builder newBuilder(SearchEvent.Builder other) {
    if (other == null) {
      return new SearchEvent.Builder();
    } else {
      return new SearchEvent.Builder(other);
    }
  }

  /**
   * Creates a new SearchEvent RecordBuilder by copying an existing SearchEvent instance.
   * @param other The existing instance to copy.
   * @return A new SearchEvent RecordBuilder
   */
  public static SearchEvent.Builder newBuilder(SearchEvent other) {
    if (other == null) {
      return new SearchEvent.Builder();
    } else {
      return new SearchEvent.Builder(other);
    }
  }

  /**
   * RecordBuilder for SearchEvent instances.
   */
  public static class Builder extends org.apache.avro.specific.SpecificRecordBuilderBase<SearchEvent>
    implements org.apache.avro.data.RecordBuilder<SearchEvent> {

    private String searchPrimaryId;
    private String userId;
    private String uuid;
    private String adId;
    private String fingerPrint;
    private String deviceId;
    private double latitude;
    private double longitude;
    private String ip;
    private String osVersion;
    private String deviceOs;
    private String clientId;
    private String appVersion;
    private String originCity;
    private String originCode;
    private String originState;
    private String originCountry;
    private String destinationCity;
    private String destinationCode;
    private String destinationState;
    private String destinationCountry;
    private String product;
    private String cabinClass;
    private long timestamp;
    private java.math.BigDecimal walletBalance;
    private int numOfAdult;
    private int numOfChildren;
    private java.time.LocalDate departureDate;
    private java.time.LocalDate arrivalDate;

    /** Creates a new Builder */
    private Builder() {
      super(SCHEMA$);
    }

    /**
     * Creates a Builder by copying an existing Builder.
     * @param other The existing Builder to copy.
     */
    private Builder(SearchEvent.Builder other) {
      super(other);
      if (isValidValue(fields()[0], other.searchPrimaryId)) {
        this.searchPrimaryId = data().deepCopy(fields()[0].schema(), other.searchPrimaryId);
        fieldSetFlags()[0] = other.fieldSetFlags()[0];
      }
      if (isValidValue(fields()[1], other.userId)) {
        this.userId = data().deepCopy(fields()[1].schema(), other.userId);
        fieldSetFlags()[1] = other.fieldSetFlags()[1];
      }
      if (isValidValue(fields()[2], other.uuid)) {
        this.uuid = data().deepCopy(fields()[2].schema(), other.uuid);
        fieldSetFlags()[2] = other.fieldSetFlags()[2];
      }
      if (isValidValue(fields()[3], other.adId)) {
        this.adId = data().deepCopy(fields()[3].schema(), other.adId);
        fieldSetFlags()[3] = other.fieldSetFlags()[3];
      }
      if (isValidValue(fields()[4], other.fingerPrint)) {
        this.fingerPrint = data().deepCopy(fields()[4].schema(), other.fingerPrint);
        fieldSetFlags()[4] = other.fieldSetFlags()[4];
      }
      if (isValidValue(fields()[5], other.deviceId)) {
        this.deviceId = data().deepCopy(fields()[5].schema(), other.deviceId);
        fieldSetFlags()[5] = other.fieldSetFlags()[5];
      }
      if (isValidValue(fields()[6], other.latitude)) {
        this.latitude = data().deepCopy(fields()[6].schema(), other.latitude);
        fieldSetFlags()[6] = other.fieldSetFlags()[6];
      }
      if (isValidValue(fields()[7], other.longitude)) {
        this.longitude = data().deepCopy(fields()[7].schema(), other.longitude);
        fieldSetFlags()[7] = other.fieldSetFlags()[7];
      }
      if (isValidValue(fields()[8], other.ip)) {
        this.ip = data().deepCopy(fields()[8].schema(), other.ip);
        fieldSetFlags()[8] = other.fieldSetFlags()[8];
      }
      if (isValidValue(fields()[9], other.osVersion)) {
        this.osVersion = data().deepCopy(fields()[9].schema(), other.osVersion);
        fieldSetFlags()[9] = other.fieldSetFlags()[9];
      }
      if (isValidValue(fields()[10], other.deviceOs)) {
        this.deviceOs = data().deepCopy(fields()[10].schema(), other.deviceOs);
        fieldSetFlags()[10] = other.fieldSetFlags()[10];
      }
      if (isValidValue(fields()[11], other.clientId)) {
        this.clientId = data().deepCopy(fields()[11].schema(), other.clientId);
        fieldSetFlags()[11] = other.fieldSetFlags()[11];
      }
      if (isValidValue(fields()[12], other.appVersion)) {
        this.appVersion = data().deepCopy(fields()[12].schema(), other.appVersion);
        fieldSetFlags()[12] = other.fieldSetFlags()[12];
      }
      if (isValidValue(fields()[13], other.originCity)) {
        this.originCity = data().deepCopy(fields()[13].schema(), other.originCity);
        fieldSetFlags()[13] = other.fieldSetFlags()[13];
      }
      if (isValidValue(fields()[14], other.originCode)) {
        this.originCode = data().deepCopy(fields()[14].schema(), other.originCode);
        fieldSetFlags()[14] = other.fieldSetFlags()[14];
      }
      if (isValidValue(fields()[15], other.originState)) {
        this.originState = data().deepCopy(fields()[15].schema(), other.originState);
        fieldSetFlags()[15] = other.fieldSetFlags()[15];
      }
      if (isValidValue(fields()[16], other.originCountry)) {
        this.originCountry = data().deepCopy(fields()[16].schema(), other.originCountry);
        fieldSetFlags()[16] = other.fieldSetFlags()[16];
      }
      if (isValidValue(fields()[17], other.destinationCity)) {
        this.destinationCity = data().deepCopy(fields()[17].schema(), other.destinationCity);
        fieldSetFlags()[17] = other.fieldSetFlags()[17];
      }
      if (isValidValue(fields()[18], other.destinationCode)) {
        this.destinationCode = data().deepCopy(fields()[18].schema(), other.destinationCode);
        fieldSetFlags()[18] = other.fieldSetFlags()[18];
      }
      if (isValidValue(fields()[19], other.destinationState)) {
        this.destinationState = data().deepCopy(fields()[19].schema(), other.destinationState);
        fieldSetFlags()[19] = other.fieldSetFlags()[19];
      }
      if (isValidValue(fields()[20], other.destinationCountry)) {
        this.destinationCountry = data().deepCopy(fields()[20].schema(), other.destinationCountry);
        fieldSetFlags()[20] = other.fieldSetFlags()[20];
      }
      if (isValidValue(fields()[21], other.product)) {
        this.product = data().deepCopy(fields()[21].schema(), other.product);
        fieldSetFlags()[21] = other.fieldSetFlags()[21];
      }
      if (isValidValue(fields()[22], other.cabinClass)) {
        this.cabinClass = data().deepCopy(fields()[22].schema(), other.cabinClass);
        fieldSetFlags()[22] = other.fieldSetFlags()[22];
      }
      if (isValidValue(fields()[23], other.timestamp)) {
        this.timestamp = data().deepCopy(fields()[23].schema(), other.timestamp);
        fieldSetFlags()[23] = other.fieldSetFlags()[23];
      }
      if (isValidValue(fields()[24], other.walletBalance)) {
        this.walletBalance = data().deepCopy(fields()[24].schema(), other.walletBalance);
        fieldSetFlags()[24] = other.fieldSetFlags()[24];
      }
      if (isValidValue(fields()[25], other.numOfAdult)) {
        this.numOfAdult = data().deepCopy(fields()[25].schema(), other.numOfAdult);
        fieldSetFlags()[25] = other.fieldSetFlags()[25];
      }
      if (isValidValue(fields()[26], other.numOfChildren)) {
        this.numOfChildren = data().deepCopy(fields()[26].schema(), other.numOfChildren);
        fieldSetFlags()[26] = other.fieldSetFlags()[26];
      }
      if (isValidValue(fields()[27], other.departureDate)) {
        this.departureDate = data().deepCopy(fields()[27].schema(), other.departureDate);
        fieldSetFlags()[27] = other.fieldSetFlags()[27];
      }
      if (isValidValue(fields()[28], other.arrivalDate)) {
        this.arrivalDate = data().deepCopy(fields()[28].schema(), other.arrivalDate);
        fieldSetFlags()[28] = other.fieldSetFlags()[28];
      }
    }

    /**
     * Creates a Builder by copying an existing SearchEvent instance
     * @param other The existing instance to copy.
     */
    private Builder(SearchEvent other) {
      super(SCHEMA$);
      if (isValidValue(fields()[0], other.searchPrimaryId)) {
        this.searchPrimaryId = data().deepCopy(fields()[0].schema(), other.searchPrimaryId);
        fieldSetFlags()[0] = true;
      }
      if (isValidValue(fields()[1], other.userId)) {
        this.userId = data().deepCopy(fields()[1].schema(), other.userId);
        fieldSetFlags()[1] = true;
      }
      if (isValidValue(fields()[2], other.uuid)) {
        this.uuid = data().deepCopy(fields()[2].schema(), other.uuid);
        fieldSetFlags()[2] = true;
      }
      if (isValidValue(fields()[3], other.adId)) {
        this.adId = data().deepCopy(fields()[3].schema(), other.adId);
        fieldSetFlags()[3] = true;
      }
      if (isValidValue(fields()[4], other.fingerPrint)) {
        this.fingerPrint = data().deepCopy(fields()[4].schema(), other.fingerPrint);
        fieldSetFlags()[4] = true;
      }
      if (isValidValue(fields()[5], other.deviceId)) {
        this.deviceId = data().deepCopy(fields()[5].schema(), other.deviceId);
        fieldSetFlags()[5] = true;
      }
      if (isValidValue(fields()[6], other.latitude)) {
        this.latitude = data().deepCopy(fields()[6].schema(), other.latitude);
        fieldSetFlags()[6] = true;
      }
      if (isValidValue(fields()[7], other.longitude)) {
        this.longitude = data().deepCopy(fields()[7].schema(), other.longitude);
        fieldSetFlags()[7] = true;
      }
      if (isValidValue(fields()[8], other.ip)) {
        this.ip = data().deepCopy(fields()[8].schema(), other.ip);
        fieldSetFlags()[8] = true;
      }
      if (isValidValue(fields()[9], other.osVersion)) {
        this.osVersion = data().deepCopy(fields()[9].schema(), other.osVersion);
        fieldSetFlags()[9] = true;
      }
      if (isValidValue(fields()[10], other.deviceOs)) {
        this.deviceOs = data().deepCopy(fields()[10].schema(), other.deviceOs);
        fieldSetFlags()[10] = true;
      }
      if (isValidValue(fields()[11], other.clientId)) {
        this.clientId = data().deepCopy(fields()[11].schema(), other.clientId);
        fieldSetFlags()[11] = true;
      }
      if (isValidValue(fields()[12], other.appVersion)) {
        this.appVersion = data().deepCopy(fields()[12].schema(), other.appVersion);
        fieldSetFlags()[12] = true;
      }
      if (isValidValue(fields()[13], other.originCity)) {
        this.originCity = data().deepCopy(fields()[13].schema(), other.originCity);
        fieldSetFlags()[13] = true;
      }
      if (isValidValue(fields()[14], other.originCode)) {
        this.originCode = data().deepCopy(fields()[14].schema(), other.originCode);
        fieldSetFlags()[14] = true;
      }
      if (isValidValue(fields()[15], other.originState)) {
        this.originState = data().deepCopy(fields()[15].schema(), other.originState);
        fieldSetFlags()[15] = true;
      }
      if (isValidValue(fields()[16], other.originCountry)) {
        this.originCountry = data().deepCopy(fields()[16].schema(), other.originCountry);
        fieldSetFlags()[16] = true;
      }
      if (isValidValue(fields()[17], other.destinationCity)) {
        this.destinationCity = data().deepCopy(fields()[17].schema(), other.destinationCity);
        fieldSetFlags()[17] = true;
      }
      if (isValidValue(fields()[18], other.destinationCode)) {
        this.destinationCode = data().deepCopy(fields()[18].schema(), other.destinationCode);
        fieldSetFlags()[18] = true;
      }
      if (isValidValue(fields()[19], other.destinationState)) {
        this.destinationState = data().deepCopy(fields()[19].schema(), other.destinationState);
        fieldSetFlags()[19] = true;
      }
      if (isValidValue(fields()[20], other.destinationCountry)) {
        this.destinationCountry = data().deepCopy(fields()[20].schema(), other.destinationCountry);
        fieldSetFlags()[20] = true;
      }
      if (isValidValue(fields()[21], other.product)) {
        this.product = data().deepCopy(fields()[21].schema(), other.product);
        fieldSetFlags()[21] = true;
      }
      if (isValidValue(fields()[22], other.cabinClass)) {
        this.cabinClass = data().deepCopy(fields()[22].schema(), other.cabinClass);
        fieldSetFlags()[22] = true;
      }
      if (isValidValue(fields()[23], other.timestamp)) {
        this.timestamp = data().deepCopy(fields()[23].schema(), other.timestamp);
        fieldSetFlags()[23] = true;
      }
      if (isValidValue(fields()[24], other.walletBalance)) {
        this.walletBalance = data().deepCopy(fields()[24].schema(), other.walletBalance);
        fieldSetFlags()[24] = true;
      }
      if (isValidValue(fields()[25], other.numOfAdult)) {
        this.numOfAdult = data().deepCopy(fields()[25].schema(), other.numOfAdult);
        fieldSetFlags()[25] = true;
      }
      if (isValidValue(fields()[26], other.numOfChildren)) {
        this.numOfChildren = data().deepCopy(fields()[26].schema(), other.numOfChildren);
        fieldSetFlags()[26] = true;
      }
      if (isValidValue(fields()[27], other.departureDate)) {
        this.departureDate = data().deepCopy(fields()[27].schema(), other.departureDate);
        fieldSetFlags()[27] = true;
      }
      if (isValidValue(fields()[28], other.arrivalDate)) {
        this.arrivalDate = data().deepCopy(fields()[28].schema(), other.arrivalDate);
        fieldSetFlags()[28] = true;
      }
    }

    /**
      * Gets the value of the 'searchPrimaryId' field.
      * @return The value.
      */
    public String getSearchPrimaryId() {
      return searchPrimaryId;
    }


    /**
      * Sets the value of the 'searchPrimaryId' field.
      * @param value The value of 'searchPrimaryId'.
      * @return This builder.
      */
    public SearchEvent.Builder setSearchPrimaryId(String value) {
      validate(fields()[0], value);
      this.searchPrimaryId = value;
      fieldSetFlags()[0] = true;
      return this;
    }

    /**
      * Checks whether the 'searchPrimaryId' field has been set.
      * @return True if the 'searchPrimaryId' field has been set, false otherwise.
      */
    public boolean hasSearchPrimaryId() {
      return fieldSetFlags()[0];
    }


    /**
      * Clears the value of the 'searchPrimaryId' field.
      * @return This builder.
      */
    public SearchEvent.Builder clearSearchPrimaryId() {
      searchPrimaryId = null;
      fieldSetFlags()[0] = false;
      return this;
    }

    /**
      * Gets the value of the 'userId' field.
      * @return The value.
      */
    public String getUserId() {
      return userId;
    }


    /**
      * Sets the value of the 'userId' field.
      * @param value The value of 'userId'.
      * @return This builder.
      */
    public SearchEvent.Builder setUserId(String value) {
      validate(fields()[1], value);
      this.userId = value;
      fieldSetFlags()[1] = true;
      return this;
    }

    /**
      * Checks whether the 'userId' field has been set.
      * @return True if the 'userId' field has been set, false otherwise.
      */
    public boolean hasUserId() {
      return fieldSetFlags()[1];
    }


    /**
      * Clears the value of the 'userId' field.
      * @return This builder.
      */
    public SearchEvent.Builder clearUserId() {
      userId = null;
      fieldSetFlags()[1] = false;
      return this;
    }

    /**
      * Gets the value of the 'uuid' field.
      * @return The value.
      */
    public String getUuid() {
      return uuid;
    }


    /**
      * Sets the value of the 'uuid' field.
      * @param value The value of 'uuid'.
      * @return This builder.
      */
    public SearchEvent.Builder setUuid(String value) {
      validate(fields()[2], value);
      this.uuid = value;
      fieldSetFlags()[2] = true;
      return this;
    }

    /**
      * Checks whether the 'uuid' field has been set.
      * @return True if the 'uuid' field has been set, false otherwise.
      */
    public boolean hasUuid() {
      return fieldSetFlags()[2];
    }


    /**
      * Clears the value of the 'uuid' field.
      * @return This builder.
      */
    public SearchEvent.Builder clearUuid() {
      uuid = null;
      fieldSetFlags()[2] = false;
      return this;
    }

    /**
      * Gets the value of the 'adId' field.
      * @return The value.
      */
    public String getAdId() {
      return adId;
    }


    /**
      * Sets the value of the 'adId' field.
      * @param value The value of 'adId'.
      * @return This builder.
      */
    public SearchEvent.Builder setAdId(String value) {
      validate(fields()[3], value);
      this.adId = value;
      fieldSetFlags()[3] = true;
      return this;
    }

    /**
      * Checks whether the 'adId' field has been set.
      * @return True if the 'adId' field has been set, false otherwise.
      */
    public boolean hasAdId() {
      return fieldSetFlags()[3];
    }


    /**
      * Clears the value of the 'adId' field.
      * @return This builder.
      */
    public SearchEvent.Builder clearAdId() {
      adId = null;
      fieldSetFlags()[3] = false;
      return this;
    }

    /**
      * Gets the value of the 'fingerPrint' field.
      * @return The value.
      */
    public String getFingerPrint() {
      return fingerPrint;
    }


    /**
      * Sets the value of the 'fingerPrint' field.
      * @param value The value of 'fingerPrint'.
      * @return This builder.
      */
    public SearchEvent.Builder setFingerPrint(String value) {
      validate(fields()[4], value);
      this.fingerPrint = value;
      fieldSetFlags()[4] = true;
      return this;
    }

    /**
      * Checks whether the 'fingerPrint' field has been set.
      * @return True if the 'fingerPrint' field has been set, false otherwise.
      */
    public boolean hasFingerPrint() {
      return fieldSetFlags()[4];
    }


    /**
      * Clears the value of the 'fingerPrint' field.
      * @return This builder.
      */
    public SearchEvent.Builder clearFingerPrint() {
      fingerPrint = null;
      fieldSetFlags()[4] = false;
      return this;
    }

    /**
      * Gets the value of the 'deviceId' field.
      * @return The value.
      */
    public String getDeviceId() {
      return deviceId;
    }


    /**
      * Sets the value of the 'deviceId' field.
      * @param value The value of 'deviceId'.
      * @return This builder.
      */
    public SearchEvent.Builder setDeviceId(String value) {
      validate(fields()[5], value);
      this.deviceId = value;
      fieldSetFlags()[5] = true;
      return this;
    }

    /**
      * Checks whether the 'deviceId' field has been set.
      * @return True if the 'deviceId' field has been set, false otherwise.
      */
    public boolean hasDeviceId() {
      return fieldSetFlags()[5];
    }


    /**
      * Clears the value of the 'deviceId' field.
      * @return This builder.
      */
    public SearchEvent.Builder clearDeviceId() {
      deviceId = null;
      fieldSetFlags()[5] = false;
      return this;
    }

    /**
      * Gets the value of the 'latitude' field.
      * @return The value.
      */
    public double getLatitude() {
      return latitude;
    }


    /**
      * Sets the value of the 'latitude' field.
      * @param value The value of 'latitude'.
      * @return This builder.
      */
    public SearchEvent.Builder setLatitude(double value) {
      validate(fields()[6], value);
      this.latitude = value;
      fieldSetFlags()[6] = true;
      return this;
    }

    /**
      * Checks whether the 'latitude' field has been set.
      * @return True if the 'latitude' field has been set, false otherwise.
      */
    public boolean hasLatitude() {
      return fieldSetFlags()[6];
    }


    /**
      * Clears the value of the 'latitude' field.
      * @return This builder.
      */
    public SearchEvent.Builder clearLatitude() {
      fieldSetFlags()[6] = false;
      return this;
    }

    /**
      * Gets the value of the 'longitude' field.
      * @return The value.
      */
    public double getLongitude() {
      return longitude;
    }


    /**
      * Sets the value of the 'longitude' field.
      * @param value The value of 'longitude'.
      * @return This builder.
      */
    public SearchEvent.Builder setLongitude(double value) {
      validate(fields()[7], value);
      this.longitude = value;
      fieldSetFlags()[7] = true;
      return this;
    }

    /**
      * Checks whether the 'longitude' field has been set.
      * @return True if the 'longitude' field has been set, false otherwise.
      */
    public boolean hasLongitude() {
      return fieldSetFlags()[7];
    }


    /**
      * Clears the value of the 'longitude' field.
      * @return This builder.
      */
    public SearchEvent.Builder clearLongitude() {
      fieldSetFlags()[7] = false;
      return this;
    }

    /**
      * Gets the value of the 'ip' field.
      * @return The value.
      */
    public String getIp() {
      return ip;
    }


    /**
      * Sets the value of the 'ip' field.
      * @param value The value of 'ip'.
      * @return This builder.
      */
    public SearchEvent.Builder setIp(String value) {
      validate(fields()[8], value);
      this.ip = value;
      fieldSetFlags()[8] = true;
      return this;
    }

    /**
      * Checks whether the 'ip' field has been set.
      * @return True if the 'ip' field has been set, false otherwise.
      */
    public boolean hasIp() {
      return fieldSetFlags()[8];
    }


    /**
      * Clears the value of the 'ip' field.
      * @return This builder.
      */
    public SearchEvent.Builder clearIp() {
      ip = null;
      fieldSetFlags()[8] = false;
      return this;
    }

    /**
      * Gets the value of the 'osVersion' field.
      * @return The value.
      */
    public String getOsVersion() {
      return osVersion;
    }


    /**
      * Sets the value of the 'osVersion' field.
      * @param value The value of 'osVersion'.
      * @return This builder.
      */
    public SearchEvent.Builder setOsVersion(String value) {
      validate(fields()[9], value);
      this.osVersion = value;
      fieldSetFlags()[9] = true;
      return this;
    }

    /**
      * Checks whether the 'osVersion' field has been set.
      * @return True if the 'osVersion' field has been set, false otherwise.
      */
    public boolean hasOsVersion() {
      return fieldSetFlags()[9];
    }


    /**
      * Clears the value of the 'osVersion' field.
      * @return This builder.
      */
    public SearchEvent.Builder clearOsVersion() {
      osVersion = null;
      fieldSetFlags()[9] = false;
      return this;
    }

    /**
      * Gets the value of the 'deviceOs' field.
      * @return The value.
      */
    public String getDeviceOs() {
      return deviceOs;
    }


    /**
      * Sets the value of the 'deviceOs' field.
      * @param value The value of 'deviceOs'.
      * @return This builder.
      */
    public SearchEvent.Builder setDeviceOs(String value) {
      validate(fields()[10], value);
      this.deviceOs = value;
      fieldSetFlags()[10] = true;
      return this;
    }

    /**
      * Checks whether the 'deviceOs' field has been set.
      * @return True if the 'deviceOs' field has been set, false otherwise.
      */
    public boolean hasDeviceOs() {
      return fieldSetFlags()[10];
    }


    /**
      * Clears the value of the 'deviceOs' field.
      * @return This builder.
      */
    public SearchEvent.Builder clearDeviceOs() {
      deviceOs = null;
      fieldSetFlags()[10] = false;
      return this;
    }

    /**
      * Gets the value of the 'clientId' field.
      * @return The value.
      */
    public String getClientId() {
      return clientId;
    }


    /**
      * Sets the value of the 'clientId' field.
      * @param value The value of 'clientId'.
      * @return This builder.
      */
    public SearchEvent.Builder setClientId(String value) {
      validate(fields()[11], value);
      this.clientId = value;
      fieldSetFlags()[11] = true;
      return this;
    }

    /**
      * Checks whether the 'clientId' field has been set.
      * @return True if the 'clientId' field has been set, false otherwise.
      */
    public boolean hasClientId() {
      return fieldSetFlags()[11];
    }


    /**
      * Clears the value of the 'clientId' field.
      * @return This builder.
      */
    public SearchEvent.Builder clearClientId() {
      clientId = null;
      fieldSetFlags()[11] = false;
      return this;
    }

    /**
      * Gets the value of the 'appVersion' field.
      * @return The value.
      */
    public String getAppVersion() {
      return appVersion;
    }


    /**
      * Sets the value of the 'appVersion' field.
      * @param value The value of 'appVersion'.
      * @return This builder.
      */
    public SearchEvent.Builder setAppVersion(String value) {
      validate(fields()[12], value);
      this.appVersion = value;
      fieldSetFlags()[12] = true;
      return this;
    }

    /**
      * Checks whether the 'appVersion' field has been set.
      * @return True if the 'appVersion' field has been set, false otherwise.
      */
    public boolean hasAppVersion() {
      return fieldSetFlags()[12];
    }


    /**
      * Clears the value of the 'appVersion' field.
      * @return This builder.
      */
    public SearchEvent.Builder clearAppVersion() {
      appVersion = null;
      fieldSetFlags()[12] = false;
      return this;
    }

    /**
      * Gets the value of the 'originCity' field.
      * @return The value.
      */
    public String getOriginCity() {
      return originCity;
    }


    /**
      * Sets the value of the 'originCity' field.
      * @param value The value of 'originCity'.
      * @return This builder.
      */
    public SearchEvent.Builder setOriginCity(String value) {
      validate(fields()[13], value);
      this.originCity = value;
      fieldSetFlags()[13] = true;
      return this;
    }

    /**
      * Checks whether the 'originCity' field has been set.
      * @return True if the 'originCity' field has been set, false otherwise.
      */
    public boolean hasOriginCity() {
      return fieldSetFlags()[13];
    }


    /**
      * Clears the value of the 'originCity' field.
      * @return This builder.
      */
    public SearchEvent.Builder clearOriginCity() {
      originCity = null;
      fieldSetFlags()[13] = false;
      return this;
    }

    /**
      * Gets the value of the 'originCode' field.
      * @return The value.
      */
    public String getOriginCode() {
      return originCode;
    }


    /**
      * Sets the value of the 'originCode' field.
      * @param value The value of 'originCode'.
      * @return This builder.
      */
    public SearchEvent.Builder setOriginCode(String value) {
      validate(fields()[14], value);
      this.originCode = value;
      fieldSetFlags()[14] = true;
      return this;
    }

    /**
      * Checks whether the 'originCode' field has been set.
      * @return True if the 'originCode' field has been set, false otherwise.
      */
    public boolean hasOriginCode() {
      return fieldSetFlags()[14];
    }


    /**
      * Clears the value of the 'originCode' field.
      * @return This builder.
      */
    public SearchEvent.Builder clearOriginCode() {
      originCode = null;
      fieldSetFlags()[14] = false;
      return this;
    }

    /**
      * Gets the value of the 'originState' field.
      * @return The value.
      */
    public String getOriginState() {
      return originState;
    }


    /**
      * Sets the value of the 'originState' field.
      * @param value The value of 'originState'.
      * @return This builder.
      */
    public SearchEvent.Builder setOriginState(String value) {
      validate(fields()[15], value);
      this.originState = value;
      fieldSetFlags()[15] = true;
      return this;
    }

    /**
      * Checks whether the 'originState' field has been set.
      * @return True if the 'originState' field has been set, false otherwise.
      */
    public boolean hasOriginState() {
      return fieldSetFlags()[15];
    }


    /**
      * Clears the value of the 'originState' field.
      * @return This builder.
      */
    public SearchEvent.Builder clearOriginState() {
      originState = null;
      fieldSetFlags()[15] = false;
      return this;
    }

    /**
      * Gets the value of the 'originCountry' field.
      * @return The value.
      */
    public String getOriginCountry() {
      return originCountry;
    }


    /**
      * Sets the value of the 'originCountry' field.
      * @param value The value of 'originCountry'.
      * @return This builder.
      */
    public SearchEvent.Builder setOriginCountry(String value) {
      validate(fields()[16], value);
      this.originCountry = value;
      fieldSetFlags()[16] = true;
      return this;
    }

    /**
      * Checks whether the 'originCountry' field has been set.
      * @return True if the 'originCountry' field has been set, false otherwise.
      */
    public boolean hasOriginCountry() {
      return fieldSetFlags()[16];
    }


    /**
      * Clears the value of the 'originCountry' field.
      * @return This builder.
      */
    public SearchEvent.Builder clearOriginCountry() {
      originCountry = null;
      fieldSetFlags()[16] = false;
      return this;
    }

    /**
      * Gets the value of the 'destinationCity' field.
      * @return The value.
      */
    public String getDestinationCity() {
      return destinationCity;
    }


    /**
      * Sets the value of the 'destinationCity' field.
      * @param value The value of 'destinationCity'.
      * @return This builder.
      */
    public SearchEvent.Builder setDestinationCity(String value) {
      validate(fields()[17], value);
      this.destinationCity = value;
      fieldSetFlags()[17] = true;
      return this;
    }

    /**
      * Checks whether the 'destinationCity' field has been set.
      * @return True if the 'destinationCity' field has been set, false otherwise.
      */
    public boolean hasDestinationCity() {
      return fieldSetFlags()[17];
    }


    /**
      * Clears the value of the 'destinationCity' field.
      * @return This builder.
      */
    public SearchEvent.Builder clearDestinationCity() {
      destinationCity = null;
      fieldSetFlags()[17] = false;
      return this;
    }

    /**
      * Gets the value of the 'destinationCode' field.
      * @return The value.
      */
    public String getDestinationCode() {
      return destinationCode;
    }


    /**
      * Sets the value of the 'destinationCode' field.
      * @param value The value of 'destinationCode'.
      * @return This builder.
      */
    public SearchEvent.Builder setDestinationCode(String value) {
      validate(fields()[18], value);
      this.destinationCode = value;
      fieldSetFlags()[18] = true;
      return this;
    }

    /**
      * Checks whether the 'destinationCode' field has been set.
      * @return True if the 'destinationCode' field has been set, false otherwise.
      */
    public boolean hasDestinationCode() {
      return fieldSetFlags()[18];
    }


    /**
      * Clears the value of the 'destinationCode' field.
      * @return This builder.
      */
    public SearchEvent.Builder clearDestinationCode() {
      destinationCode = null;
      fieldSetFlags()[18] = false;
      return this;
    }

    /**
      * Gets the value of the 'destinationState' field.
      * @return The value.
      */
    public String getDestinationState() {
      return destinationState;
    }


    /**
      * Sets the value of the 'destinationState' field.
      * @param value The value of 'destinationState'.
      * @return This builder.
      */
    public SearchEvent.Builder setDestinationState(String value) {
      validate(fields()[19], value);
      this.destinationState = value;
      fieldSetFlags()[19] = true;
      return this;
    }

    /**
      * Checks whether the 'destinationState' field has been set.
      * @return True if the 'destinationState' field has been set, false otherwise.
      */
    public boolean hasDestinationState() {
      return fieldSetFlags()[19];
    }


    /**
      * Clears the value of the 'destinationState' field.
      * @return This builder.
      */
    public SearchEvent.Builder clearDestinationState() {
      destinationState = null;
      fieldSetFlags()[19] = false;
      return this;
    }

    /**
      * Gets the value of the 'destinationCountry' field.
      * @return The value.
      */
    public String getDestinationCountry() {
      return destinationCountry;
    }


    /**
      * Sets the value of the 'destinationCountry' field.
      * @param value The value of 'destinationCountry'.
      * @return This builder.
      */
    public SearchEvent.Builder setDestinationCountry(String value) {
      validate(fields()[20], value);
      this.destinationCountry = value;
      fieldSetFlags()[20] = true;
      return this;
    }

    /**
      * Checks whether the 'destinationCountry' field has been set.
      * @return True if the 'destinationCountry' field has been set, false otherwise.
      */
    public boolean hasDestinationCountry() {
      return fieldSetFlags()[20];
    }


    /**
      * Clears the value of the 'destinationCountry' field.
      * @return This builder.
      */
    public SearchEvent.Builder clearDestinationCountry() {
      destinationCountry = null;
      fieldSetFlags()[20] = false;
      return this;
    }

    /**
      * Gets the value of the 'product' field.
      * @return The value.
      */
    public String getProduct() {
      return product;
    }


    /**
      * Sets the value of the 'product' field.
      * @param value The value of 'product'.
      * @return This builder.
      */
    public SearchEvent.Builder setProduct(String value) {
      validate(fields()[21], value);
      this.product = value;
      fieldSetFlags()[21] = true;
      return this;
    }

    /**
      * Checks whether the 'product' field has been set.
      * @return True if the 'product' field has been set, false otherwise.
      */
    public boolean hasProduct() {
      return fieldSetFlags()[21];
    }


    /**
      * Clears the value of the 'product' field.
      * @return This builder.
      */
    public SearchEvent.Builder clearProduct() {
      product = null;
      fieldSetFlags()[21] = false;
      return this;
    }

    /**
      * Gets the value of the 'cabinClass' field.
      * @return The value.
      */
    public String getCabinClass() {
      return cabinClass;
    }


    /**
      * Sets the value of the 'cabinClass' field.
      * @param value The value of 'cabinClass'.
      * @return This builder.
      */
    public SearchEvent.Builder setCabinClass(String value) {
      validate(fields()[22], value);
      this.cabinClass = value;
      fieldSetFlags()[22] = true;
      return this;
    }

    /**
      * Checks whether the 'cabinClass' field has been set.
      * @return True if the 'cabinClass' field has been set, false otherwise.
      */
    public boolean hasCabinClass() {
      return fieldSetFlags()[22];
    }


    /**
      * Clears the value of the 'cabinClass' field.
      * @return This builder.
      */
    public SearchEvent.Builder clearCabinClass() {
      cabinClass = null;
      fieldSetFlags()[22] = false;
      return this;
    }

    /**
      * Gets the value of the 'timestamp' field.
      * @return The value.
      */
    public long getTimestamp() {
      return timestamp;
    }


    /**
      * Sets the value of the 'timestamp' field.
      * @param value The value of 'timestamp'.
      * @return This builder.
      */
    public SearchEvent.Builder setTimestamp(long value) {
      validate(fields()[23], value);
      this.timestamp = value;
      fieldSetFlags()[23] = true;
      return this;
    }

    /**
      * Checks whether the 'timestamp' field has been set.
      * @return True if the 'timestamp' field has been set, false otherwise.
      */
    public boolean hasTimestamp() {
      return fieldSetFlags()[23];
    }


    /**
      * Clears the value of the 'timestamp' field.
      * @return This builder.
      */
    public SearchEvent.Builder clearTimestamp() {
      fieldSetFlags()[23] = false;
      return this;
    }

    /**
      * Gets the value of the 'walletBalance' field.
      * @return The value.
      */
    public java.math.BigDecimal getWalletBalance() {
      return walletBalance;
    }


    /**
      * Sets the value of the 'walletBalance' field.
      * @param value The value of 'walletBalance'.
      * @return This builder.
      */
    public SearchEvent.Builder setWalletBalance(java.math.BigDecimal value) {
      validate(fields()[24], value);
      this.walletBalance = value;
      fieldSetFlags()[24] = true;
      return this;
    }

    /**
      * Checks whether the 'walletBalance' field has been set.
      * @return True if the 'walletBalance' field has been set, false otherwise.
      */
    public boolean hasWalletBalance() {
      return fieldSetFlags()[24];
    }


    /**
      * Clears the value of the 'walletBalance' field.
      * @return This builder.
      */
    public SearchEvent.Builder clearWalletBalance() {
      walletBalance = null;
      fieldSetFlags()[24] = false;
      return this;
    }

    /**
      * Gets the value of the 'numOfAdult' field.
      * @return The value.
      */
    public int getNumOfAdult() {
      return numOfAdult;
    }


    /**
      * Sets the value of the 'numOfAdult' field.
      * @param value The value of 'numOfAdult'.
      * @return This builder.
      */
    public SearchEvent.Builder setNumOfAdult(int value) {
      validate(fields()[25], value);
      this.numOfAdult = value;
      fieldSetFlags()[25] = true;
      return this;
    }

    /**
      * Checks whether the 'numOfAdult' field has been set.
      * @return True if the 'numOfAdult' field has been set, false otherwise.
      */
    public boolean hasNumOfAdult() {
      return fieldSetFlags()[25];
    }


    /**
      * Clears the value of the 'numOfAdult' field.
      * @return This builder.
      */
    public SearchEvent.Builder clearNumOfAdult() {
      fieldSetFlags()[25] = false;
      return this;
    }

    /**
      * Gets the value of the 'numOfChildren' field.
      * @return The value.
      */
    public int getNumOfChildren() {
      return numOfChildren;
    }


    /**
      * Sets the value of the 'numOfChildren' field.
      * @param value The value of 'numOfChildren'.
      * @return This builder.
      */
    public SearchEvent.Builder setNumOfChildren(int value) {
      validate(fields()[26], value);
      this.numOfChildren = value;
      fieldSetFlags()[26] = true;
      return this;
    }

    /**
      * Checks whether the 'numOfChildren' field has been set.
      * @return True if the 'numOfChildren' field has been set, false otherwise.
      */
    public boolean hasNumOfChildren() {
      return fieldSetFlags()[26];
    }


    /**
      * Clears the value of the 'numOfChildren' field.
      * @return This builder.
      */
    public SearchEvent.Builder clearNumOfChildren() {
      fieldSetFlags()[26] = false;
      return this;
    }

    /**
      * Gets the value of the 'departureDate' field.
      * @return The value.
      */
    public java.time.LocalDate getDepartureDate() {
      return departureDate;
    }


    /**
      * Sets the value of the 'departureDate' field.
      * @param value The value of 'departureDate'.
      * @return This builder.
      */
    public SearchEvent.Builder setDepartureDate(java.time.LocalDate value) {
      validate(fields()[27], value);
      this.departureDate = value;
      fieldSetFlags()[27] = true;
      return this;
    }

    /**
      * Checks whether the 'departureDate' field has been set.
      * @return True if the 'departureDate' field has been set, false otherwise.
      */
    public boolean hasDepartureDate() {
      return fieldSetFlags()[27];
    }


    /**
      * Clears the value of the 'departureDate' field.
      * @return This builder.
      */
    public SearchEvent.Builder clearDepartureDate() {
      departureDate = null;
      fieldSetFlags()[27] = false;
      return this;
    }

    /**
      * Gets the value of the 'arrivalDate' field.
      * @return The value.
      */
    public java.time.LocalDate getArrivalDate() {
      return arrivalDate;
    }


    /**
      * Sets the value of the 'arrivalDate' field.
      * @param value The value of 'arrivalDate'.
      * @return This builder.
      */
    public SearchEvent.Builder setArrivalDate(java.time.LocalDate value) {
      validate(fields()[28], value);
      this.arrivalDate = value;
      fieldSetFlags()[28] = true;
      return this;
    }

    /**
      * Checks whether the 'arrivalDate' field has been set.
      * @return True if the 'arrivalDate' field has been set, false otherwise.
      */
    public boolean hasArrivalDate() {
      return fieldSetFlags()[28];
    }


    /**
      * Clears the value of the 'arrivalDate' field.
      * @return This builder.
      */
    public SearchEvent.Builder clearArrivalDate() {
      arrivalDate = null;
      fieldSetFlags()[28] = false;
      return this;
    }

    @Override
    @SuppressWarnings("unchecked")
    public SearchEvent build() {
      try {
        SearchEvent record = new SearchEvent();
        record.searchPrimaryId = fieldSetFlags()[0] ? this.searchPrimaryId : (String) defaultValue(fields()[0]);
        record.userId = fieldSetFlags()[1] ? this.userId : (String) defaultValue(fields()[1]);
        record.uuid = fieldSetFlags()[2] ? this.uuid : (String) defaultValue(fields()[2]);
        record.adId = fieldSetFlags()[3] ? this.adId : (String) defaultValue(fields()[3]);
        record.fingerPrint = fieldSetFlags()[4] ? this.fingerPrint : (String) defaultValue(fields()[4]);
        record.deviceId = fieldSetFlags()[5] ? this.deviceId : (String) defaultValue(fields()[5]);
        record.latitude = fieldSetFlags()[6] ? this.latitude : (Double) defaultValue(fields()[6]);
        record.longitude = fieldSetFlags()[7] ? this.longitude : (Double) defaultValue(fields()[7]);
        record.ip = fieldSetFlags()[8] ? this.ip : (String) defaultValue(fields()[8]);
        record.osVersion = fieldSetFlags()[9] ? this.osVersion : (String) defaultValue(fields()[9]);
        record.deviceOs = fieldSetFlags()[10] ? this.deviceOs : (String) defaultValue(fields()[10]);
        record.clientId = fieldSetFlags()[11] ? this.clientId : (String) defaultValue(fields()[11]);
        record.appVersion = fieldSetFlags()[12] ? this.appVersion : (String) defaultValue(fields()[12]);
        record.originCity = fieldSetFlags()[13] ? this.originCity : (String) defaultValue(fields()[13]);
        record.originCode = fieldSetFlags()[14] ? this.originCode : (String) defaultValue(fields()[14]);
        record.originState = fieldSetFlags()[15] ? this.originState : (String) defaultValue(fields()[15]);
        record.originCountry = fieldSetFlags()[16] ? this.originCountry : (String) defaultValue(fields()[16]);
        record.destinationCity = fieldSetFlags()[17] ? this.destinationCity : (String) defaultValue(fields()[17]);
        record.destinationCode = fieldSetFlags()[18] ? this.destinationCode : (String) defaultValue(fields()[18]);
        record.destinationState = fieldSetFlags()[19] ? this.destinationState : (String) defaultValue(fields()[19]);
        record.destinationCountry = fieldSetFlags()[20] ? this.destinationCountry : (String) defaultValue(fields()[20]);
        record.product = fieldSetFlags()[21] ? this.product : (String) defaultValue(fields()[21]);
        record.cabinClass = fieldSetFlags()[22] ? this.cabinClass : (String) defaultValue(fields()[22]);
        record.timestamp = fieldSetFlags()[23] ? this.timestamp : (Long) defaultValue(fields()[23]);
        record.walletBalance = fieldSetFlags()[24] ? this.walletBalance : (java.math.BigDecimal) defaultValue(fields()[24]);
        record.numOfAdult = fieldSetFlags()[25] ? this.numOfAdult : (Integer) defaultValue(fields()[25]);
        record.numOfChildren = fieldSetFlags()[26] ? this.numOfChildren : (Integer) defaultValue(fields()[26]);
        record.departureDate = fieldSetFlags()[27] ? this.departureDate : (java.time.LocalDate) defaultValue(fields()[27]);
        record.arrivalDate = fieldSetFlags()[28] ? this.arrivalDate : (java.time.LocalDate) defaultValue(fields()[28]);
        return record;
      } catch (Exception e) {
        throw new org.apache.avro.AvroRuntimeException(e);
      }
    }
  }

  @SuppressWarnings("unchecked")
  private static final org.apache.avro.io.DatumWriter<SearchEvent>
    WRITER$ = (org.apache.avro.io.DatumWriter<SearchEvent>)MODEL$.createDatumWriter(SCHEMA$);

  @Override public void writeExternal(java.io.ObjectOutput out)
    throws java.io.IOException {
    WRITER$.write(this, SpecificData.getEncoder(out));
  }

  @SuppressWarnings("unchecked")
  private static final org.apache.avro.io.DatumReader<SearchEvent>
    READER$ = (org.apache.avro.io.DatumReader<SearchEvent>)MODEL$.createDatumReader(SCHEMA$);

  @Override public void readExternal(java.io.ObjectInput in)
    throws java.io.IOException {
    READER$.read(this, SpecificData.getDecoder(in));
  }

}










